/*******************************************************************************

        @file XmlLayout.d

        Copyright (C) 2004 Kris Bell
        
        This software is provided 'as-is', without any express or implied
        warranty. In no event will the authors be held liable for damages
        of any kind arising from the use of this software.
        
        Permission is hereby granted to anyone to use this software for any 
        purpose, including commercial applications, and to alter it and/or 
        redistribute it freely, subject to the following restrictions:
        
        1. The origin of this software must not be misrepresented; you must 
           not claim that you wrote the original software. If you use this 
           software in a product, an acknowledgment within documentation of 
           said product would be appreciated but is not required.

        2. Altered source versions must be plainly marked as such, and must 
           not be misrepresented as being the original software.

        3. This notice may not be removed or altered from any distribution
           of the source.


                        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

      
        @version        Initial version, May 2004
        @author         Kris


*******************************************************************************/

module mango.log.XmlLayout;

private import  std.c.time,
                std.c.stdio;

private import  mango.log.Event,
                mango.log.Layout;

/*******************************************************************************

        A layout with XML output conforming to LOG4J specs.
       
*******************************************************************************/

public class XmlLayout : Layout
{
        version (Win32)
                 alias _snprintf snprintf;

        /***********************************************************************
                
                Format message attributes into an output buffer and return
                the populated portion.

        ***********************************************************************/

        char[] format (Event event)
        {
                char[] scratch = event.getScratch();
                char[] level = levelString (event);
                level = level[0..level.length-1];

                int i = snprintf (scratch, scratch.length, "<log4j:event logger=\"%.*s\" timestamp=\"%llu\" level=\"%.*s\" thread=\"unknown\">\r\n<log4j:message><![CDATA[%.*s]]></log4j:message>\r\n<log4j:properties><log4j:data name=\"application\" value=\"%.*s\"/><log4j:data name=\"hostname\" value=\"%.*s\"/></log4j:properties></log4j:event>\r\n",
                                  event.getName(),
                                  event.getEpochMilliSeconds(),
                                  level,
                                  event.toString(),
                                  event.getHierarchy.getName(),
                                  event.getHierarchy.getAddress());
            
                return scratch[0..i];
        }
}


